﻿namespace PlayingWithClasses
{
  using System;

  public class Program
  {
    static void Main(string[] args)
    {
      MyClass playingWithClasses = new MyClass();
      MyClass myClassesResult = playingWithClasses.MyMethodOne().MyMethodTwo();

      MyClass myClassesNewInstanceResult = playingWithClasses.MyMethodNewInstanceOne().MyMethodNewInstanceTwo();

      Console.WriteLine("************* without new instance *************");

      Console.WriteLine("One: " + myClassesResult.mOne);
      Console.WriteLine("Two: " + myClassesResult.mTwo);
      Console.WriteLine("All: " + myClassesResult.mAll);

      Console.WriteLine("************* with new instance *************");

      Console.WriteLine("One: " + myClassesNewInstanceResult.mOne);
      Console.WriteLine("Two: " + myClassesNewInstanceResult.mTwo);
      Console.WriteLine("All: " + myClassesNewInstanceResult.mAll);

      Console.WriteLine("Press any key");

      Console.ReadKey();
    }

    public class MyClass
    {
      public string mOne = "none";
      public string mTwo = "none";
      public string mAll = "none";

      public MyClass MyMethodOne()
      {
        this.mOne = "I am from method one";
        this.mAll = "My name is all and I am also from method one";
        return this;
      }

      public MyClass MyMethodTwo()
      {
        this.mTwo = "I am from method two";
        this.mAll = "My name is all and I am also from method two";

        return this;
      }

      public MyClass MyMethodNewInstanceOne()
      {
        MyClass something = new MyClass();

        something.mOne = "I am from method one";
        something.mAll = "My name is all and I am also from method one";
        return this;
      }

      public MyClass MyMethodNewInstanceTwo()
      {
        MyClass something = new MyClass();

        something.mTwo = "I am from method two";
        something.mAll = "My name is all and I am also from method two";

        return something;
      }

    }

  }
}